#include "scope.h"
#include <unity/scopes/SearchQueryBase.h>
#include <unity/scopes/ReplyProxyFwd.h>
#include <mediascanner/MediaStore.hh>
#include <mediascanner/Filter.hh>
#include <QString>
#include <QLocale>

class Query : public unity::scopes::SearchQueryBase
{
public:
    Query(const unity::scopes::CannedQuery &query, const unity::scopes::SearchMetadata &, Scope & );
    ~Query();
    virtual void cancelled() override;

    virtual void run(unity::scopes::SearchReplyProxy const& reply) override;

private:
    mediascanner::Filter *filter;
    QLocale locale;
    Scope & scope_;
    const unity::scopes::CannedQuery cannedQuery;
    std::string query_;
    std::pair <QString,QString> albums(unity::scopes::SearchReplyProxy const&, QString &);

    QString album(unity::scopes::SearchReplyProxy const&, QString &, QString &);

    struct mediaUnknown {
        std::string date;
        std::string time;
        std::string uri;
        std::string artUri;
        std::string title;
    };

    const std::string CATEGORY_TEMPLATE = R"({
        "schema-version" : 1,
        "template" : {
            "category-layout" : "grid",
            "card-size": "small"
        },
        "components" : {
            "title" : "title",
            "art" : "art"
        }
        })";
};
