#include"preview.h"
#include "i18n.h"

#include <unity/scopes/PreviewQueryBase.h>
#include<unity/scopes/PreviewWidget.h>
#include<unity/scopes/ColumnLayout.h>
#include<unity/scopes/PreviewReply.h>
#include <unity/scopes/VariantBuilder.h>

#include <QDebug>
#include <map>
#include <string>
#include <iostream>
#include <fstream>

using namespace unity::scopes;

Preview::Preview(Result const& result, ActionMetadata const& metadata) :
    PreviewQueryBase(result, metadata),
    result_(result)
{
}

Preview::~Preview()
{
}

void Preview::cancelled()
{
}

void Preview::run(unity::scopes::PreviewReplyProxy const& reply)
{
    ColumnLayout layout1col(1);
    layout1col.add_column({"artId", "text2", "text3", "actionsId"});

    ColumnLayout layout2col(2);
    layout2col.add_column({"artId"});
    layout2col.add_column({"text2", "text3", "actionsId"});

    ColumnLayout layout3col(3);
    layout3col.add_column({"artId"});
    layout3col.add_column({"text2", "text3", "actionsId"});
    layout3col.add_column({});
    reply->register_layout({layout1col, layout2col, layout3col});

    PreviewWidget w_header("headerId", "header");
    w_header.add_attribute_mapping("title", "title");

    PreviewWidget w_image("artId", "image");
    w_image.add_attribute_mapping("source", "art");
    w_image.add_attribute_value("zoomable", Variant(true));

    PreviewWidget w_text2("text2", "text");
    w_text2.add_attribute_mapping("text", "date");

    PreviewWidget w_text3("text3", "text");
    w_text3.add_attribute_mapping("text", "time");

    PreviewWidget w_actions("actionsId", "actions");
    VariantBuilder builder;
    builder.add_tuple({
        {"id", Variant("open")},
        {"label", Variant(_("Open"))}
    });
    w_actions.add_attribute_value("actions", builder.end());

    PreviewWidgetList widgets({w_image, w_text2, w_text3, w_actions});

    reply->push(widgets);
}
