#include "scope.h"
#include "query.h"
#include "preview.h"
#include "utils.h"

#include <unity-scopes.h>
#include <mediascanner/MediaFile.hh>
#include <mediascanner/MediaStore.hh>

#include <QCoreApplication>
#include <QThread>
#include <QDebug>

namespace us = unity::scopes;
using namespace mediascanner;

Scope::Scope()
{
}

void Scope::start(std::string const&)
{
    store.reset(new MediaStore(MS_READ_WRITE));
}

void Scope::stop()
{
    store.reset();
}

void Scope::run()
{

}

us::SearchQueryBase::UPtr Scope::search(us::CannedQuery const &q,
                                        us::SearchMetadata const &metadata )
{
    us::SearchQueryBase::UPtr cannedQuery(new Query(q,
                                          metadata,
                                          *this
                                          ));
    //writeIt("form factor:" + metadata.form_factor());
    //writeIt("locale:" + metadata.locale());
    //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
    return cannedQuery;
}

us::PreviewQueryBase::UPtr Scope::preview(us::Result const& result, us::ActionMetadata const& metadata ) {
    us::PreviewQueryBase::UPtr preview(new Preview(result, metadata));
    return preview;
}

#define EXPORT __attribute__ ((visibility ("default")))

extern "C"
{

    EXPORT
    us::ScopeBase*
    // cppcheck-suppress unusedFunction
    UNITY_SCOPE_CREATE_FUNCTION()
    {
        return new Scope();
    }

    EXPORT
    void
    // cppcheck-suppress unusedFunction
    UNITY_SCOPE_DESTROY_FUNCTION(us::ScopeBase* scope_base)
    {
        delete scope_base;
    }

}
